



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#编程总结（十三）数据压缩</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#编程总结（十三）数据压缩</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 11:39:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>C#编程总结（十三）数据压缩</h1>
<p>在进行文件存储或者数据传输时，为了节省空间流量，需要对数据或文件进行压缩。在这里我们讲述通过C#实现数据压缩。</p>
<h2>一、GZipStream压缩</h2>
<p>微软提供用于压缩和解压缩流的方法。</p>
<p>此类表示 GZip 数据格式，它使用无损压缩和解压缩文件的行业标准算法。 这种格式包括一个检测数据损坏的循环冗余校验值。 GZip 数据格式使用的算法与 DeflateStream 类的算法相同，但它可以扩展以使用其他压缩格式。 这种格式可以通过不涉及专利使用权的方式轻松实现。</p>
<p>可以使用许多常见的压缩工具对写入到扩展名为 .gz 的文件的压缩 GZipStream 对象进行解压缩；但是，此类原本并不提供用于向 .zip 存档中添加文件或从 .zip 存档中提取文件的功能。</p>
<p>DeflateStream 和 GZipStream 中的压缩功能作为流公开。 由于数据是以逐字节的方式读取的，因此无法通过进行多次传递来确定压缩整个文件或大型数据块的最佳方法。 对于未压缩的数据源，最好使用 DeflateStream 和 GZipStream 类。 如果源数据已压缩，则使用这些类时实际上可能会增加流的大小。</p>
<p><strong>具体实现源码</strong></p>
<h3>1、压缩字节数组</h3>
<div>
<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 压缩字节数组<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="str"&gt;&lt;/param&gt;<br />
        public static byte[] Compress(byte[] inputBytes)<br />
        {<br />
            using (MemoryStream outStream = new MemoryStream())<br />
            {<br />
                using (GZipStream zipStream = new GZipStream(outStream, CompressionMode.Compress, true))<br />
                {<br />
                    zipStream.Write(inputBytes, , inputBytes.Length);<br />
                    zipStream.Close(); //很重要，必须关闭，否则无法正确解压<br />
                    return outStream.ToArray();<br />
                }<br />
            }<br />
        }

        /// &lt;summary&gt;<br />
        /// 解压缩字节数组<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="str"&gt;&lt;/param&gt;<br />
        public static byte[] Decompress(byte[] inputBytes)<br />
        {

            using (MemoryStream inputStream = new MemoryStream(inputBytes))<br />
            {<br />
                using (MemoryStream outStream = new MemoryStream())<br />
                {<br />
                    using (GZipStream zipStream = new GZipStream(inputStream, CompressionMode.Decompress))<br />
                    {<br />
                        zipStream.CopyTo(outStream);<br />
                        zipStream.Close();<br />
                        return outStream.ToArray();<br />
                    }<br />
                }

            }<br />
        }</pre>
</div>
<h3>2、压缩字符串</h3>
<p>在压缩字节的基础扩展而来，注意字符转换，保证不出现乱码。具体原理，这里不再介绍，可见：</p>
<p>C#编程总结（十）字符转码&nbsp;<a href="http://www.cnblogs.com/yank/p/3536863.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yank/p/3536863.html</a></p>
<div>
<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 压缩字符串<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="input"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string Compress(string input)<br />
        {<br />
            byte[] inputBytes = Encoding.Default.GetBytes(input);<br />
            byte[] result = Compress(inputBytes);<br />
            return Convert.ToBase64String(result);<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 解压缩字符串<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="input"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string Decompress(string input)<br />
        {<br />
            byte[] inputBytes = Convert.FromBase64String(input);<br />
            byte[] depressBytes = Decompress(inputBytes);<br />
            return Encoding.Default.GetString(depressBytes);<br />
        }</pre>
</div>
<h3>3、压缩文件</h3>
<p>如果你试图自己做一个压缩工具，相比这个方法很管用</p>
<div>
<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 压缩目录<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="dir"&gt;&lt;/param&gt;<br />
        public static void Compress(DirectoryInfo dir)<br />
        {<br />
            foreach (FileInfo fileToCompress in dir.GetFiles())<br />
            {<br />
                Compress(fileToCompress);<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 解压缩目录<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="dir"&gt;&lt;/param&gt;<br />
        public static void Decompress(DirectoryInfo dir)<br />
        {<br />
            foreach (FileInfo fileToCompress in dir.GetFiles())<br />
            {<br />
                Decompress(fileToCompress);<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 压缩文件<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="fileToCompress"&gt;&lt;/param&gt;<br />
        public static void Compress(FileInfo fileToCompress)<br />
        {<br />
            using (FileStream originalFileStream = fileToCompress.OpenRead())<br />
            {<br />
                if ((File.GetAttributes(fileToCompress.FullName) &amp; FileAttributes.Hidden) != FileAttributes.Hidden &amp; fileToCompress.Extension != ".gz")<br />
                {<br />
                    using (FileStream compressedFileStream = File.Create(fileToCompress.FullName + ".gz"))<br />
                    {<br />
                        using (GZipStream compressionStream = new GZipStream(compressedFileStream, CompressionMode.Compress))<br />
                        {<br />
                            originalFileStream.CopyTo(compressionStream);<br />
                        }<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 解压缩文件<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="fileToDecompress"&gt;&lt;/param&gt;<br />
        public static void Decompress(FileInfo fileToDecompress)<br />
        {<br />
            using (FileStream originalFileStream = fileToDecompress.OpenRead())<br />
            {<br />
                string currentFileName = fileToDecompress.FullName;<br />
                string newFileName = currentFileName.Remove(currentFileName.Length - fileToDecompress.Extension.Length);

                using (FileStream decompressedFileStream = File.Create(newFileName))<br />
                {<br />
                    using (GZipStream decompressionStream = new GZipStream(originalFileStream, CompressionMode.Decompress))<br />
                    {<br />
                        decompressionStream.CopyTo(decompressedFileStream);<br />
                    }<br />
                }<br />
            }<br />
        }</pre>
</div>
<h2>二、开源组件ICSharpCode.SharpZipLib进行压缩</h2>
<p>ICSharpCode.SharpZipLib，开源组件，支持Zip,GZip,BZip2,Tar等</p>
<p>其压缩效率及压缩比比微软自带的要好。并提供了源码，开源对其算法进行研究、改进。具体可见：</p>
<p><a href="http://www.icsharpcode.net/OpenSource/SharpZipLib/" rel="external nofollow noreferrer">http://www.icsharpcode.net/OpenSource/SharpZipLib/</a></p>
<p>这里提供简单的一种实现以供参考，其他算法比较类似，不再赘述。</p>
<h3>1、使用BZip2压缩字符串</h3>
<div>
<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 压缩<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="input"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string Compress(string input)<br />
        {<br />
            string result = string.Empty;<br />
            byte[] buffer = Encoding.UTF8.GetBytes(input);<br />
            using (MemoryStream outputStream = new MemoryStream())<br />
            {<br />
                using (BZip2OutputStream zipStream = new BZip2OutputStream(outputStream))<br />
                {<br />
                    zipStream.Write(buffer, , buffer.Length);<br />
                    zipStream.Close();<br />
                }<br />
                return Convert.ToBase64String(outputStream.ToArray());<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 解压缩<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="input"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string Decompress(string input)<br />
        {<br />
            string result = string.Empty;<br />
            byte[] buffer = Convert.FromBase64String(input);<br />
            using (Stream inputStream = new MemoryStream(buffer))<br />
            {<br />
                BZip2InputStream zipStream = new BZip2InputStream(inputStream);

                using (StreamReader reader = new StreamReader(zipStream, Encoding.UTF8))<br />
                {<br />
                    //输出<br />
                    result = reader.ReadToEnd();<br />
                }<br />
            }

            return result;<br />
        }</pre>
</div>
<h2>三、Demo下载地址</h2>
<p><a href="http://files.cnblogs.com/yank/CompressSample.zip" rel="external nofollow noreferrer">http://files.cnblogs.com/yank/CompressSample.zip</a></p>
<h2>四、后续</h2>
<p>如有其他更好的压缩方法，请指出。后续会更新至此。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eyklx9.html">linux 高性能服务器编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq15oz59.html">xml 基础学习备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlvpg09.html">Python 3&period;6&period;0的sqlite3模块无法执行VACUUM语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnx5oj9.html">SQL：将字符串以特定字符分割并返回Table</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e140xz9.html">HackerRank &amp;quot&semi;Vertical Rooks&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd5drjq.html">COALESCE在SQL拼接中的大用途</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z13ddn9.html">Metadata Lock原理4</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7l7y9.html">Mac 启用http-dav功能&lpar;WebDAV服务器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xgkz9.html">Javascript中setTimeout和setInterval的区别和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljmj5e9.html">关于android的nfc问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mmd1n8.html">NYOJ129 决策树 【并检查集合】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzd248.html">Java 解析 lnk 快捷方式文件的方法&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj45dlq.html">CODE&lbrack;VS&rsqb;-求和-整数处理-天梯青铜</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pmymn8.html">Lambda表达式介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge27e48.html">Spring MVC 表单校验 （七）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdj55q.html">1&period;4 flask request和session</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2r626q.html">verilog 有符号数运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwrk548.html">移动端设置&comma; mobile &comma;   一张图片作为背景 &comma;平铺 &comma;自动拉伸 &comma;  图片 铺满视界 &comma;窗口&period; background-image &comma;  background-size&comma;  background-repeat</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjxnd28.html">UVA10047&lowbar;The Monocycle</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn00ljq.html">Android Studio2&period;3&period;3卡在Building &apos;xxx&apos; Gradle project info的解决方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r933zlg9.html">使用hexo&plus;github搭建免费个人博客详细教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z6wwnq.html">图文详解Unity3D中Material的Tiling和Offset是怎么回事</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r6v449.html">如何在 ASP&period;NET MVC 中集成 AngularJS（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/3904z4j8.html">js中setTimeout&lpar;&rpar;的使用bug</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwn6jyq.html">EF架构~通过EF6的DbCommand拦截器来实现数据库读写分离~终结~配置的优化和事务里读写的统一</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2g7go8.html">PHP性能优化工具&ndash;xhprof安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8er1rjq.html">初次使用IDEA的相关技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn41638.html">那些年我们写过的T-SQL（下篇）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96z00jq.html">javascript基础语法&mdash;&mdash;变量和标识符</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q70e7k8.html">开发笔记：用Owin Host实现脱离IIS跑Web API单元测试</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
